--[[uart.setup(2, 9600, 8, uart.PARITY_NONE, uart.STOPBITS_1, {tx = 16, rx = 17})
uart.start(2)
--]]
if not dat then dat = {} end
if not pzem then pzem = {} end

bus = require('_modbus')
parce_pzem = function (ok, gotuartt)
	if not ok then 
		print('Lost Modbus Unit')
		return 
	end
	pzem.unit = gotuartt[1]
	--table.foreach(gotuartt, print)
	local raw = ''
	for i=1, #gotuartt do  
		raw = raw..gotuartt[i]..', '
	end
	print(raw)

	if m and dat.broker then
		m:publish(dat.clnt..'/'..'raw', raw, 2, 0)
	end
	pzem.raw = raw
	local calc = gotuartt[5]
	calc = calc + bit.lshift(gotuartt[4],8)
	pzem.volt = calc / 10
	print('\n\nUnit = ', gotuartt[1])

	print('Volt:', pzem.volt)
	if gotuartt[11] then
		calc = gotuartt[7] + bit.lshift(gotuartt[6],8) + bit.lshift(gotuartt[9],16) + bit.lshift(gotuartt[8],32)
		pzem.current = calc / 1000
		print('Current = ', pzem.current)
	end
	if gotuartt[15] then
		calc = gotuartt[11] + bit.lshift(gotuartt[10],8) + bit.lshift(gotuartt[13],16) + bit.lshift(gotuartt[12],32)
		pzem.power = calc / 10
		print('Power = ', pzem.power)
	end
	if gotuartt[19] then
		calc = gotuartt[15] + bit.lshift(gotuartt[14],8) + bit.lshift(gotuartt[17],16) + bit.lshift(gotuartt[16],32)
		pzem.energy = calc
		print('Energy = ', pzem.energy)
	end
	if gotuartt[21] then
		calc = gotuartt[19] + bit.lshift(gotuartt[18],8)
		pzem.frequency = calc/10
		print('Frequency = ', pzem.frequency)
	end
	--dat[gotuartt[1]] = pzem
	dofile'mqttpub.lua'
end

modtb = {1,4,0,0,0,8}
stepbus = 1
maxbus = 3

maintmr = tmr.create() 
maintmr:register(10000, 1, function()
	local modtb = {1,4,0,0,0,8}
	print('\n\nAsk Unit: '..stepbus)
	modtb[1] = stepbus
	bus.askpzem(modtb, parce_pzem)
	stepbus = stepbus + 1
	if stepbus > maxbus then stepbus = 1 end  
end)
maintmr:start()
